import {Reaction} from "../Common/Models";

export interface ReducerEventArgs {
    action: any;
    state: any;
}

export interface BaseReducerOptions {
    events?: {
        onReducing?: (e: ReducerEventArgs) => void;
        onReduced?: (e: ReducerEventArgs) => void;
    }
    _notYet_shouldLog?: never;
    _notYet_expiration?: {
        timeout: number;
    }
}


export const onlyOneExists = (...params: any) => params.filter((p: any) => p).length == 1;

export const addBaseOptionsToReducer = (reducer: Reaction, reducerOptions: BaseReducerOptions) => {
    reducer = addEventsToReducer(reducer, reducerOptions);

    return reducer;
};

export const addEventsToReducer = (reducer: (state: any, action: any) => any, reducerOptions: BaseReducerOptions) => {
    return (state: any, action: any) => {
        if (reducerOptions.events && reducerOptions.events.onReducing)
            reducerOptions.events.onReducing({state, action});

        const newState = reducer(state, action);

        if (reducerOptions.events && reducerOptions.events.onReduced)
            reducerOptions.events.onReduced({state: newState, action});

        return newState;
    }
};